--- perly.c.orig	2006-05-11 10:52:38.000000000 +0200
+++ perly.c	2006-05-11 10:52:38.000000000 +0200
@@ -1,5 +1,5 @@
 #ifndef lint
-static char yysccsid[] = "@(#)yaccpar 1.8 (Berkeley) 01/20/91";
+/* static char yysccsid[] = "@(#)yaccpar 1.8 (Berkeley) 01/20/91"; */
 #endif
 #define YYBYACC 1
 #line 25 "perly.y"
@@ -9,7 +9,7 @@
 #ifdef EBCDIC
 #undef YYDEBUG
 #endif
-#define dep() deprecate("\"do\" to call subroutines")
+#define dep() deprecate_old("\"do\" to call subroutines")
 
 /* stuff included here to make perly_c.diff apply better */
 
@@ -50,73 +50,9 @@
 #define yylex yylex_r
 #endif
 
-#line 54 "y.tab.c"
-#define WORD 257
-#define METHOD 258
-#define FUNCMETH 259
-#define THING 260
-#define PMFUNC 261
-#define PRIVATEREF 262
-#define FUNC0SUB 263
-#define UNIOPSUB 264
-#define LSTOPSUB 265
-#define LABEL 266
-#define FORMAT 267
-#define SUB 268
-#define ANONSUB 269
-#define PACKAGE 270
-#define USE 271
-#define WHILE 272
-#define UNTIL 273
-#define IF 274
-#define UNLESS 275
-#define ELSE 276
-#define ELSIF 277
-#define CONTINUE 278
-#define FOR 279
-#define LOOPEX 280
-#define DOTDOT 281
-#define FUNC0 282
-#define FUNC1 283
-#define FUNC 284
-#define UNIOP 285
-#define LSTOP 286
-#define RELOP 287
-#define EQOP 288
-#define MULOP 289
-#define ADDOP 290
-#define DOLSHARP 291
-#define DO 292
-#define HASHBRACK 293
-#define NOAMP 294
-#define LOCAL 295
-#define MY 296
-#define MYSUB 297
-#define REQUIRE 298
-#define COLONATTR 299
-#define PREC_LOW 300
-#define OROP 301
-#define DOROP 302
-#define ANDOP 303
-#define NOTOP 304
-#define ASSIGNOP 305
-#define OROR 306
-#define DORDOR 307
-#define ANDAND 308
-#define BITOROP 309
-#define BITANDOP 310
-#define SHIFTOP 311
-#define MATCHOP 312
-#define UMINUS 313
-#define REFGEN 314
-#define POWOP 315
-#define PREINC 316
-#define PREDEC 317
-#define POSTINC 318
-#define POSTDEC 319
-#define ARROW 320
+#line 52 "perly.c"
 #define YYERRCODE 256
-short yylhs[] = {                                        -1,
+static short yylhs[] = {                                        -1,
     0,   10,    8,    7,   11,    9,   12,   12,   12,   13,
    13,   13,   13,   26,   26,   26,   26,   26,   26,   26,
    16,   16,   16,   15,   15,   43,   43,   14,   14,   14,
@@ -139,7 +75,7 @@
    44,   25,   20,   21,   22,   23,   24,   36,   36,   36,
    36,
 };
-short yylen[] = {                                         2,
+static short yylen[] = {                                         2,
     2,    4,    0,    0,    4,    0,    0,    2,    2,    2,
     1,    2,    3,    1,    1,    3,    3,    3,    3,    3,
     0,    2,    6,    7,    7,    0,    2,    9,    9,   10,
@@ -162,7 +98,7 @@
     1,    2,    2,    2,    2,    2,    2,    1,    1,    1,
     1,
 };
-short yydefred[] = {                                      4,
+static short yydefred[] = {                                      4,
     0,    7,    0,   45,   58,   56,    0,   56,   56,    8,
    46,    9,   11,   48,    0,   47,   49,   50,    0,    0,
     0,   70,   71,    0,   14,    3,  177,    0,    0,  156,
@@ -205,7 +141,7 @@
     0,    0,   31,    5,    0,   30,    0,    0,    0,    0,
    33,   23,
 };
-short yydgoto[] = {                                       1,
+static short yydgoto[] = {                                       1,
    10,   11,   20,  105,   19,  363,    2,   96,  377,   99,
   366,    3,   12,   13,   71,  380,  289,   73,   74,   75,
    76,   77,   78,   79,   80,  296,   82,  297,  287,  236,
@@ -213,7 +149,7 @@
   198,  332,  158,  294,  277,  229,   14,   84,  138,   85,
    86,   87,   88,   15,   16,   17,   18,   94,  284,
 };
-short yysindex[] = {                                      0,
+static short yysindex[] = {                                      0,
     0,    0, -228,    0,    0,    0,  -56,    0,    0,    0,
     0,    0,    0,    0,  796,    0,    0,    0, -230, -225,
    24,    0,    0, -225,    0,    0,    0,  172,  172,    0,
@@ -256,7 +192,7 @@
  -185, 1669,    0,    0,  370,    0,  373,  215,  215, -241,
     0,    0,
 };
-short yyrindex[] = {                                      0,
+static short yyrindex[] = {                                      0,
     0,    0,  383,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,    0,    0,    0,    0,  292,    0,
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
@@ -299,7 +235,7 @@
    17,  394,    0,    0,    0,    0,    0,    0,    0,   96,
     0,    0,
 };
-short yygindex[] = {                                      0,
+static short yygindex[] = {                                      0,
     0,    0,   43,  411,    0, -321,    0,  803,    0,  166,
   630,  -84,    0,    0,    0, -339,  -15,   58,    0, 2512,
   396,  397,    0,    0,    0,  435,  501,    0,  118, -120,
@@ -308,7 +244,7 @@
     0,    0,    0,    0,    0,    0,    0,    0,    0,
 };
 #define YYTABLESIZE 4809
-short yytable[] = {                                      72,
+static short yytable[] = {                                      72,
   231,   60,   22,  301,  224,  202,  310,  232,   60,   66,
   281,  201,  330,  112,  320,   62,   26,   66,  364,   64,
   186,  260,  279,  222,  298,  189,   89,  381,  285,   15,
@@ -791,7 +727,7 @@
     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     0,    0,    0,    0,  112,  112,  112,    0,  112,
 };
-short yycheck[] = {                                      15,
+static short yycheck[] = {                                      15,
    41,   59,   59,   41,   59,  101,   41,   93,  123,   36,
   203,   96,   59,   40,   59,   59,    0,   36,  340,   59,
    40,   40,  200,   40,  212,   91,  257,  367,  206,   41,
@@ -1280,7 +1216,7 @@
 #endif
 #define YYMAXTOKEN 320
 #if YYDEBUG
-char *yyname[] = {
+static char *yyname[] = {
 "end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 "'!'",0,0,"'$'","'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'",0,0,0,0,0,0,0,
 0,0,0,0,0,"':'","';'",0,0,0,"'?'","'@'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
@@ -1297,7 +1233,7 @@
 "ASSIGNOP","OROR","DORDOR","ANDAND","BITOROP","BITANDOP","SHIFTOP","MATCHOP",
 "UMINUS","REFGEN","POWOP","PREINC","PREDEC","POSTINC","POSTDEC","ARROW",
 };
-char *yyrule[] = {
+static char *yyrule[] = {
 "$accept : prog",
 "prog : progstart lineseq",
 "block : '{' remember lineseq '}'",
@@ -1516,17 +1452,6 @@
 #define YYMAXDEPTH 500
 #endif
 #endif
-int yydebug;
-int yynerrs;
-int yyerrflag;
-int yychar;
-short *yyssp;
-YYSTYPE *yyvsp;
-YYSTYPE yyval;
-YYSTYPE yylval;
-short yyss[YYSTACKSIZE];
-YYSTYPE yyvs[YYSTACKSIZE];
-#define yystacksize YYSTACKSIZE
 #line 816 "perly.y"
  /* PROGRAM */
 
@@ -1537,7 +1462,7 @@
 #endif
 #define yyparse() Perl_yyparse(pTHX)
 
-#line 1541 "y.tab.c"
+#line 1464 "perly.c"
 #define YYABORT goto yyabort
 #define YYACCEPT goto yyaccept
 #define YYERROR goto yyerrlab
@@ -1545,11 +1470,31 @@
 yyparse()
 {
     register int yym, yyn, yystate;
+    register short *yyssp;
+    register YYSTYPE *yyvsp;
+    short* yyss;
+    YYSTYPE* yyvs;
+    unsigned yystacksize = YYSTACKSIZE;
+    int retval = 0;
 #if YYDEBUG
     register char *yys;
-    extern char *getenv();
+#endif
+
+    struct ysv *ysave;
+#ifdef USE_ITHREADS
+    ENTER;			/* force yydestruct() before we return */
+#endif
+    New(73, ysave, 1, struct ysv);
+    SAVEDESTRUCTOR_X(yydestruct, ysave);
+    ysave->oldyydebug	= yydebug;
+    ysave->oldyynerrs	= yynerrs;
+    ysave->oldyyerrflag	= yyerrflag;
+    ysave->oldyychar	= yychar;
+    ysave->oldyyval	= yyval;
+    ysave->oldyylval	= yylval;
 
-    if (yys = getenv("YYDEBUG"))
+#if YYDEBUG
+    if ((yys = getenv("YYDEBUG")))
     {
         yyn = *yys;
         if (yyn >= '0' && yyn <= '9')
@@ -1561,12 +1506,22 @@
     yyerrflag = 0;
     yychar = (-1);
 
+    /*
+    ** Initialize private stacks (yyparse may be called from an action)
+    */
+    New(73, yyss, yystacksize, short);
+    New(73, yyvs, yystacksize, YYSTYPE);
+    ysave->yyss = yyss;
+    ysave->yyvs = yyvs;
+    if (!yyvs || !yyss)
+	goto yyoverflow;
+
     yyssp = yyss;
     yyvsp = yyvs;
     *yyssp = yystate = 0;
 
 yyloop:
-    if (yyn = yydefred[yystate]) goto yyreduce;
+    if ((yyn = yydefred[yystate])) goto yyreduce;
     if (yychar < 0)
     {
         if ((yychar = yylex()) < 0) yychar = 0;
@@ -1576,7 +1531,7 @@
             yys = 0;
             if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
             if (!yys) yys = "illegal-symbol";
-            printf("yydebug: state %d, reading %d (%s)\n", yystate,
+            PerlIO_printf(Perl_debug_log, "yydebug: state %d, reading %d (%s)\n", yystate,
                     yychar, yys);
         }
 #endif
@@ -1586,12 +1541,24 @@
     {
 #if YYDEBUG
         if (yydebug)
-            printf("yydebug: state %d, shifting to state %d\n",
+            PerlIO_printf(Perl_debug_log, "yydebug: state %d, shifting to state %d\n",
                     yystate, yytable[yyn]);
 #endif
         if (yyssp >= yyss + yystacksize - 1)
         {
+	    /*
+	    ** reallocate and recover.  Note that pointers
+	    ** have to be reset, or bad things will happen
+	    */
+	    int yyps_index = (yyssp - yyss);
+	    int yypv_index = (yyvsp - yyvs);
+	    yystacksize += YYSTACKSIZE;
+	    ysave->yyvs = Renew(yyvs, yystacksize, YYSTYPE);
+	    ysave->yyss = Renew(yyss, yystacksize, short);
+	    if (!yyvs || !yyss)
             goto yyoverflow;
+	    yyssp = yyss + yyps_index;
+	    yyvsp = yyvs + yypv_index;
         }
         *++yyssp = yystate = yytable[yyn];
         *++yyvsp = yylval;
@@ -1607,14 +1574,14 @@
     }
     if (yyerrflag) goto yyinrecovery;
 #ifdef lint
-    goto yynewerror;
+
 #endif
-yynewerror:
+
     yyerror("syntax error");
 #ifdef lint
-    goto yyerrlab;
+
 #endif
-yyerrlab:
+
     ++yynerrs;
 yyinrecovery:
     if (yyerrflag < 3)
@@ -1627,12 +1594,24 @@
             {
 #if YYDEBUG
                 if (yydebug)
-                    printf("yydebug: state %d, error recovery shifting\
+                    PerlIO_printf(Perl_debug_log, "yydebug: state %d, error recovery shifting\
  to state %d\n", *yyssp, yytable[yyn]);
 #endif
                 if (yyssp >= yyss + yystacksize - 1)
                 {
+		    /*
+		    ** reallocate and recover.  Note that pointers
+		    ** have to be reset, or bad things will happen
+		    */
+		    int yyps_index = (yyssp - yyss);
+		    int yypv_index = (yyvsp - yyvs);
+		    yystacksize += YYSTACKSIZE;
+		    ysave->yyvs = Renew(yyvs, yystacksize, YYSTYPE);
+		    ysave->yyss = Renew(yyss, yystacksize, short);
+		    if (!yyvs || !yyss)
                     goto yyoverflow;
+		    yyssp = yyss + yyps_index;
+		    yyvsp = yyvs + yypv_index;
                 }
                 *++yyssp = yystate = yytable[yyn];
                 *++yyvsp = yylval;
@@ -1642,7 +1621,7 @@
             {
 #if YYDEBUG
                 if (yydebug)
-                    printf("yydebug: error recovery discarding state %d\n",
+                    PerlIO_printf(Perl_debug_log, "yydebug: error recovery discarding state %d\n",
                             *yyssp);
 #endif
                 if (yyssp <= yyss) goto yyabort;
@@ -1660,7 +1639,7 @@
             yys = 0;
             if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
             if (!yys) yys = "illegal-symbol";
-            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
+            PerlIO_printf(Perl_debug_log, "yydebug: state %d, error recovery discards token %d (%s)\n",
                     yystate, yychar, yys);
         }
 #endif
@@ -1670,7 +1649,7 @@
 yyreduce:
 #if YYDEBUG
     if (yydebug)
-        printf("yydebug: state %d, reducing by rule %d (%s)\n",
+        PerlIO_printf(Perl_debug_log, "yydebug: state %d, reducing by rule %d (%s)\n",
                 yystate, yyn, yyrule[yyn]);
 #endif
     yym = yylen[yyn];
@@ -2553,7 +2532,7 @@
 #line 813 "perly.y"
 { yyval.opval = yyvsp[0].opval; }
 break;
-#line 2557 "y.tab.c"
+#line 2480 "perly.c"
     }
     yyssp -= yym;
     yystate = *yyssp;
@@ -2563,7 +2542,7 @@
     {
 #if YYDEBUG
         if (yydebug)
-            printf("yydebug: after reduction, shifting from state 0 to\
+            PerlIO_printf(Perl_debug_log, "yydebug: after reduction, shifting from state 0 to\
  state %d\n", YYFINAL);
 #endif
         yystate = YYFINAL;
@@ -2578,7 +2557,7 @@
                 yys = 0;
                 if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                 if (!yys) yys = "illegal-symbol";
-                printf("yydebug: state %d, reading %d (%s)\n",
+                PerlIO_printf(Perl_debug_log, "yydebug: state %d, reading %d (%s)\n",
                         YYFINAL, yychar, yys);
             }
 #endif
@@ -2593,20 +2572,50 @@
         yystate = yydgoto[yym];
 #if YYDEBUG
     if (yydebug)
-        printf("yydebug: after reduction, shifting from state %d \
+        PerlIO_printf(Perl_debug_log, "yydebug: after reduction, shifting from state %d \
 to state %d\n", *yyssp, yystate);
 #endif
     if (yyssp >= yyss + yystacksize - 1)
     {
+	/*
+	** reallocate and recover.  Note that pointers
+	** have to be reset, or bad things will happen
+	*/
+	int yyps_index = (yyssp - yyss);
+	int yypv_index = (yyvsp - yyvs);
+	yystacksize += YYSTACKSIZE;
+	ysave->yyvs = Renew(yyvs, yystacksize, YYSTYPE);
+	ysave->yyss = Renew(yyss, yystacksize, short);
+	if (!yyvs || !yyss)
         goto yyoverflow;
+	yyssp = yyss + yyps_index;
+	yyvsp = yyvs + yypv_index;
     }
     *++yyssp = yystate;
     *++yyvsp = yyval;
     goto yyloop;
 yyoverflow:
-    yyerror("yacc stack overflow");
+    yyerror("Out of memory for yacc stack");
 yyabort:
-    return (1);
+    retval = 1;
 yyaccept:
-    return (0);
+#ifdef USE_ITHREADS
+    LEAVE;			/* force yydestruct() before we return */
+#endif
+    return retval;
+}
+
+static void
+yydestruct(pTHX_ void *ptr)
+{
+    struct ysv* ysave = (struct ysv*)ptr;
+    if (ysave->yyss) Safefree(ysave->yyss);
+    if (ysave->yyvs) Safefree(ysave->yyvs);
+    yydebug	= ysave->oldyydebug;
+    yynerrs	= ysave->oldyynerrs;
+    yyerrflag	= ysave->oldyyerrflag;
+    yychar	= ysave->oldyychar;
+    yyval	= ysave->oldyyval;
+    yylval	= ysave->oldyylval;
+    Safefree(ysave);
 }
